100 REMark $$asmb=win1_uti_mag_MAG_BIN,0,10
102 :
104 EXT_FN 'RPIX%', 'RPIXL', 'GET_FSPR', 'SP_FRAME'
106 :
108 REMark     Simple magnifier tool
110 REMark V0.01, pjw, June 10th 2019
112 REMark V0.03, pjw, 2024 May 05, Include mode 0
114 REMark Needs ptrmen_cde and, in QL mode only, Qptr
116 :
118 REMark DO to move display
120 REMark HIT to magnify area under sprite
122 REMark K or k to keep (save magnification to file)
124 REMark ESC to quit
126 :
128 COLOUR_NATIVE
130 :
132 IF LEN(CMD$) = 0 THEN
134  mg% = 4:               REMark Magnification factor 2, 3, 4..
136 ELSE
138  mg% = CMD$
140 END IF
142 :
144 REMark $$off
146 IF PEEK$(\\ -4, 4) = 'SBAS' THEN
148  LRESPR HOME_DIR$ & 'MAG_BIN'
150 END IF
152 REMark $$on
154 :
158 spr = GET_FSPR(SP_FRAME)
166 :
168 REMark     Init
170 ch = FOPEN("con")
172 wx% = SCR_XLIM(#ch): wy% = SCR_YLIM(#ch)
174 WINDOW#ch; wx%, wy%, 0, 0: OUTL
176 SPRS#ch; spr
178 :
180 sx% = PEEK_W(spr + 4): sy% = PEEK_W(spr + 6)
182 vx% = sx% * mg%: vy% = sy% * mg%
184 px% = wx% - vx%: py% = 0
186 ym% = wy% - sy%:        REMark Max y
188 :
190 scr = WSAIN(#ch; vx%, vy%)
192 WSASV#ch; scr, vx%, vy%, px%, py%
194 MoveDisplay px%, py%
196 :
198 REMark     Do it!
200 tv% = 8 + 1: x% = -1: y% = x%: t% = x%
202 REPeat lp
204  RDPT#ch; tv%, x%, y%, t%
206  k% = tv% DIV 256
208  SELect ON k%
210   =  0: REMark Moving pointer
212   =  1: IF y% > ym% THEN
214          BEEP 99, 1: Magnify x%, ym% - sy%
216         ELSE
218          Magnify x%, y%
220         END IF
222   = 75, 107: Keep
224   =  2: MoveDisplay x%, y%
226   = 27: EXIT lp
228   = REMAINDER : BEEP 999, 100
230  END SELect
232 END REPeat lp
234 QUIT
236 :
238 :
240 DEFine PROCedure Magnify(xx%, yy%)
242 LOCal x%, y%, c%
244 :
246 IF DISP_TYPE = 0 THEN
248  FOR y% = 0 TO sy% - 1
250   FOR x% = 0 TO sx% - 1
252    c% = RPIXL(#ch; xx% + x%, yy% + y%)
254    BLOCK#ch; mg%, mg%, px% + x% * mg%, py% + y% * mg%, c%
256   END FOR x%
258  END FOR y%
260 ELSE
262  FOR y% = 0 TO sy% - 1
264   FOR x% = 0 TO sx% - 1
266    c% = RPIX%(#ch; xx% + x%, yy% + y%)
268    BLOCK#ch; mg%, mg%, px% + x% * mg%, py% + y% * mg%, c%
270   END FOR x%
272  END FOR y%
274 END IF
276 END DEFine Magnify
278 :
280 :
282 DEFine PROCedure MoveDisplay(xx%, yy%)
284 WSARS#ch; scr\ vx%, vy%, px%, py%
286 :
288 px% = xx%
290 IF xx% + sx% * mg% > wx%: px% = wx% - sx% * mg%
292 :
294 py% = yy%
296 IF yy% + sy% * mg% > wy%: py% = wy% - sy% * mg%
298 :
300 WSASV#ch; scr, vx%, vy%, px%, py%
302 BLOCK#ch; vx%, vy%, px%, py%, -1
304 END DEFine MoveDisplay
306 :
308 :
310 DEFine PROCedure Keep
312 LOCal i%, adr, ok
314 ok = 0
316 FOR i% = 0 TO 9
318  IF FTEST("ram1_mag" & i% & '_pic') = -7 THEN
320   adr = WSAIN(#ch; vx%, vy%)
322   WSASV#ch; adr, vx%, vy%, px%, py%
324   S_WSA#ch; adr, 'ram1_mag' & i% & '_pic'
326   RECHP adr
328   ok = 1: BEEP 1000, 1: EXIT i%
330  END IF
332 END FOR i%
334 IF NOT ok: BEEP 2000, 200
336 END DEFine Keep
338 :
340 :
